<?php
/** 
Plugin Name: news ticker benaceur
Plugin URI: https://benaceur-php.com/
Description: This plugin allow you to display the latest posts or latest comments in a bar with twenty seven beautiful animations and effects...
Version: 2.7.3
Author: benaceur
Author URI: https://benaceur-php.com/
License: GPL2
*/

if ( ! defined( 'ABSPATH' ) ) exit;

if (!defined('NTB_VERSION_BEN')) define("NTB_VERSION_BEN", "2.5.9");
if (!defined('NS_TR_BEN')) define("NS_TR_BEN", "news_ticker_benaceur");
if (!defined('NTB_BEN_O_G')) define("NTB_BEN_O_G", "options-general.php");

if (!defined('NTB_BEN_NAME'))
    define('NTB_BEN_NAME', trim(dirname(plugin_basename(__FILE__)), '/'));

if (!defined('NTB_BEN_DIR'))
    define('NTB_BEN_DIR', WP_PLUGIN_DIR . '/' . NTB_BEN_NAME);

if (!defined('NTB_BEN_URL'))
    define('NTB_BEN_URL', WP_PLUGIN_URL . '/' . NTB_BEN_NAME);

    function wp_news_ticker_benaceur_() { 
      do_action('wp_news_ticker_benaceur');
    }

class class______news_ticker_benaceur {


    function __construct(){
		
	add_action( 'wp_news_ticker_benaceur', array($this, 'wp_news_ticker_benaceur___') );
    add_filter('plugin_action_links_'.plugin_basename(__FILE__), array($this, 'action_links'));
	add_action('init', array($this, 'text_domain'));
	add_action('admin_menu', array($this, 'menu'));
	add_action('admin_init', array($this, 'register_options'));
	add_action('init', array($this, 'options_default_up'));
	add_action('admin_init', array($this, 'activ_redir'));
	register_activation_hook( __FILE__, array($this, 'up_options'));
	add_shortcode('wp_news_ticker_benaceur_short_code', array($this, 'shortcode_ntb_func'));
	add_action('wp_enqueue_scripts', array($this, 'scripts_'));
	add_action('admin_bar_menu', array($this, 'links_on_admin_bar'), 99);
	add_action('admin_init', array($this, 'admin_notices'));
	register_deactivation_hook( __FILE__, array($this, 'plugin_deactivation'));
    add_action('admin_init', array($this, 'reset_options'));
    add_action('wp_ntb_msg_update', array($this, 'verPlug'));
	add_action( 'admin_init', array($this, 'process_settings_export_import'));
    }

    function ntb_version() {
		
    $plugin_data = get_plugin_data( __FILE__ );
    $plugin_version = $plugin_data['Version'];
    return $plugin_version;
    }
	
    function latest_version($plugin){

			if( ! function_exists( 'plugins_api' ) ) {
				include_once ABSPATH . '/wp-admin/includes/plugin-install.php'; 
			}
			$api = plugins_api( 'plugin_information', array(
			'slug' => $plugin,
			'fields' => array( 'version' => true )
			) );
			
			if( is_wp_error( $api ) ) return;
			
				return $api->version;
    }

  function action_links($links){
  $links[] = '<a href="'.get_admin_url(null, NTB_BEN_O_G.'?page='.NS_TR_BEN).'">'.__("Settings", 'news-ticker-benaceur').'</a>';
  return $links;
  }

  function text_domain() {
  load_plugin_textdomain( 'news-ticker-benaceur', false, dirname( plugin_basename( __FILE__ ) ) . '/lang/' );
  }

  function menu() {
  $menu = add_options_page('news-ticker-benaceur', 'News-Ticker-Benaceur', apply_filters( 'ntb_manage_options_cap', 'manage_options' ), ''.NS_TR_BEN.'', array($this,'page_options'));
  add_action("admin_print_styles-$menu", array($this, 'js_page_panel'));
  }
  
  function AllOptionsNTB() {
  return array(
  'news_ticker_benaceur_for_visitors',
  'news_ticker_benaceur_links_admin_bar_front',
  'news_ticker_benaceur_links_admin_bar_admin',  
  'news_ticker_benaceur_enable_plug',
  'news_ticker_benaceur_for_users',
  'news_ticker_benaceur_for_role_x',
  'news_ticker_benaceur_for_user_id',
  'news_ticker_benaceur_links_admin_bar_menu',
  'news_ticker_benaceur_dir',
  'news_ticker_benaceur_for_cat_tax',
  'news_ticker_benaceur_for_cat',
  'news_ticker_benaceur_for_all_expt_admin',
  'news_ticker_benaceur_in_home',
  'news_ticker_benaceur_in_single',
  'news_ticker_benaceur_in_page',
  'news_ticker_benaceur_in_category',
  'news_ticker_benaceur_in_author',
  'news_ticker_benaceur_in_search',
  'news_ticker_benaceur_in_page_id',
  'news_ticker_benaceur_in_single_id',
  'news_ticker_benaceur_title_ltr',
  'news_ticker_benaceur_title_rtl',
  'news_ticker_benaceur_num_posts',
  'news_ticker_benaceur_disable_title',
  'news_ticker_benaceur_latest_p_c',
  'news_ticker_benaceur_include_exclude_id',
  'news_ticker_benaceur_post_type',
  'news_ticker_benaceur_post_status',
  'news_ticker_benaceur_comment_status',
  'news_ticker_benaceur_expt_txt_title',
  'news_ticker_benaceur_expt_txt_comm',
  'news_ticker_benaceur_title_anim_pulsate',
  'news_ticker_benaceur_title_styles',
  'news_ticker_benaceur_title_styles_topleft_le',
  'news_ticker_benaceur_title_styles_topright_le',
  'news_ticker_benaceur_title_styles_topleft_ri',
  'news_ticker_benaceur_title_styles_topright_ri',
  'news_ticker_benaceur_title_styles_bottomright',
  'news_ticker_benaceur_title_styles_bottomleft',
  'ntb_group_reset'
   );
  }
  
  function AllOptionssNTB() {
  return array(
  'news_ticker_benaceur_color_back_',
  'news_ticker_benaceur_color_back_title',
  'news_ticker_benaceur_color_text_back',
  'news_ticker_benaceur_color_text_title',
  'news_ticker_benaceur_color_border',
  'news_ticker_benaceur_border_top',
  'news_ticker_benaceur_border_bottom',
  'news_ticker_benaceur_border_right',
  'news_ticker_benaceur_border_left',
  'news_ticker_benaceur_border_radius',
  'news_ticker_benaceur_opacity',
  'news_ticker_benaceur_font_family',
  'news_ticker_benaceur_font_size',
  'news_ticker_benaceur_font_size_title',
  'news_ticker_benaceur_width',
  'news_ticker_benaceur_padding_top',
  'news_ticker_benaceur_padding_bottom',
  'news_ticker_benaceur_margin_top',
  'news_ticker_benaceur_margin_bottom',
  'news_ticker_benaceur_font_weight',
  'news_ticker_benaceur_text_shadow',
  'news_ticker_benaceur_text_shadow_color',
  'news_ticker_benaceur_box_shadow',
  'news_ticker_benaceur_box_shadow_color',
  'news_ticker_benaceur_box_shadow_v',
  'news_ticker_benaceur_PrevNext_color',
  'news_ticker_benaceur_PrevNext_font_size',
  'news_ticker_benaceur_title_font_family',
  'news_ticker_benaceur_PrevNext_weight',
  'news_ticker_benaceur_PrevNext_top',
  'news_ticker_benaceur_enable_style_mobile',
  'news_ticker_benaceur_screen_max_width',
  'news_ticker_benaceur_screen_min_width',
  'news_ticker_benaceur_height_mobile',
  'news_ticker_benaceur_padding_top_mobile',
  'news_ticker_benaceur_padding_right_left_mobile',
  'news_ticker_benaceur_min_height_mobile',
  'news_ticker_benaceur_line_height_mobile',
  'news_ticker_benaceur_disable_in_screen_max_width',
  'news_ticker_benaceur_v_screen_max_width',
  'news_ticker_benaceur_disable_this_font',
  'news_ticker_benaceur_padding_top_title',
  'news_ticker_benaceur_default',
  'news_ticker_benaceur_height',
  'news_ticker_benaceur_a_hover',
  'news_ticker_benaceur_hide_icon_evol_plug',
  'news_ticker_benaceur_time_export_sett_gmt',
  'news_ticker_benaceur_color_border_title',
  'news_ticker_benaceur_border_title',
  'news_ticker_benaceur_line_height_title',
  'news_ticker_benaceur_width_title_background',
  'ntb_group_sty_reset'
   );
  }
  
  function AllOptions_anim_NTB() {
  return array(
  'news_ticker_benaceur_timeout_tickerntb',
  'news_ticker_benaceur_speedIn_typing_2',
  'news_ticker_benaceur_anim_speed_anms_two',
  'news_ticker_benaceur_anim_timeout_anms_two',
  'news_ticker_benaceur_anim_timeout_typing_2',
  'news_ticker_benaceur_speed_scrollntb_',
  'news_ticker_benaceur_pause_scrollntb',
  'news_ticker_benaceur_disa_img_n_scrollup',
  'news_ticker_benaceur_expt_title_scrollntb',
  'news_ticker_benaceur_all_scrollntb',
  'news_ticker_benaceur_disa_img_n_fadein',
  'news_ticker_benaceur_dis_fin_img_scrollntb',
  'news_ticker_benaceur_dis_fin_no_img_scrollntb',
  'news_ticker_benaceur_ena_js_scrollntb',
  'news_ticker_benaceur_style',
  'news_ticker_benaceur_timeout_slide_up_down',
  'news_ticker_benaceur_speed_slide_up_down',
  'news_ticker_benaceur_updown_slide_up_down',
  'news_ticker_benaceur_pause_slide_up_down',
  'news_ticker_benaceur_autostart_slide_up_down',
  'news_ticker_benaceur_timeout_fadein',
  'news_ticker_benaceur_pause_fadein',
  'news_ticker_benaceur_pause_typing',
  'news_ticker_benaceur_autostart_fadein',
  'news_ticker_benaceur_width_anms__two',
  'news_ticker_benaceur_width_typing__2',
  'news_ticker_benaceur_timeout_no_scr_typ',
  'news_ticker_benaceur_speed_no_scr_typ',
  'news_ticker_benaceur_margin_top_no_scr_typ',
  'news_ticker_benaceur_margin_left_ltr_no_scr_typ',
  'news_ticker_benaceur_margin_right_ltr_no_scr_typ',
  'news_ticker_benaceur_cursor_no_scr_typ',
  'news_ticker_benaceur_cursor_top_no_scr_typ_',
  'news_ticker_benaceur_cursor_margin_left_right_no_scr_typ',
  'news_ticker_benaceur_NP_img_no_scr_typ',
  'news_ticker_benaceur_NP_img_anms_two',
  'news_ticker_benaceur_NP_img_typing_2',
  'news_ticker_benaceur_pause_anms_two',
  'news_ticker_benaceur_pause_typing_2',
  'news_ticker_benaceur_ENABLE_curs_no_scr_typ',
  'news_ticker_benaceur_dist_from_left_right_fadein',
  'news_ticker_benaceur_dist_from_left_right_scrollup',
  'news_ticker_benaceur_dist_from_left_right_scrollntb',
  'news_ticker_benaceur_dist_between_scrollntb',
  'news_ticker_benaceur_w_img_scrollntb',
  'news_ticker_benaceur_h_img_scrollntb',
  'news_ticker_benaceur_ri_le_img_scrollntb',
  'news_ticker_benaceur_le_ri_img_scrollntb',
  'ntb_group_anim_reset'
   );
  }

  function register_options() {
	
  register_setting('news_ticker_benaceur_group_op', 'news_ticker_benaceur_delete_all_options');
  register_setting('news_ticker_benaceur_group_op', 'news_ticker_benaceur_ntb_st_code');
  register_setting('news_ticker_benaceur_all_reset', 'ntb_all_reset');

  foreach($this->AllOptionsNTB() as $optionN_NTB) {
    register_setting('news_ticker_benaceur_group', $optionN_NTB);
}	

  foreach($this->AllOptionssNTB() as $optionS_NTB ) {
    register_setting('news_ticker_benaceur_group_sty', $optionS_NTB);
}

  foreach($this->AllOptions_anim_NTB() as $optionN_anim_NTB) {
    register_setting('news_ticker_benaceur_group_anim', $optionN_anim_NTB);
}	
	
}
// add_option
     function group_options_default() {
      add_option( 'news_ticker_benaceur_title_ltr', 'Latest news');
      add_option( 'news_ticker_benaceur_title_rtl', 'آخر الأخبار');
      add_option( 'news_ticker_benaceur_enable_plug', '1');
      add_option('news_ticker_benaceur_links_admin_bar_menu', 'menu');
      add_option('news_ticker_benaceur_dir', 'auto');
      add_option('news_ticker_benaceur_num_posts', '10');
      add_option('news_ticker_benaceur_latest_p_c', 'latest_posts');
      add_option('news_ticker_benaceur_for_cat_tax', 'category');
      add_option('news_ticker_benaceur_include_exclude_id', 'include_id');
      add_option('news_ticker_benaceur_post_type', 'post');
      add_option('news_ticker_benaceur_post_status', 'publish');
      add_option('news_ticker_benaceur_comment_status', 'approve');
      add_option('news_ticker_benaceur_expt_txt_title', '62');
      add_option('news_ticker_benaceur_expt_txt_comm', '62');
      add_option('news_ticker_benaceur_title_styles_topleft_le', '0');
      add_option('news_ticker_benaceur_title_styles_topright_le', '34');
      add_option('news_ticker_benaceur_title_styles_topleft_ri', '34');
      add_option('news_ticker_benaceur_title_styles_topright_ri', '0');
      add_option('news_ticker_benaceur_title_styles_bottomright', '0');
      add_option('news_ticker_benaceur_title_styles_bottomleft', '0');
	 }
	 
     function group_anim_options_default() {
      add_option('news_ticker_benaceur_style', 'fadein');
      add_option('news_ticker_benaceur_timeout_tickerntb', '5000');
      add_option('news_ticker_benaceur_speedIn_typing_2', '4000');
      add_option('news_ticker_benaceur_anim_speed_anms_two', '1000');
      add_option('news_ticker_benaceur_anim_timeout_anms_two', '2000');
      add_option('news_ticker_benaceur_anim_timeout_typing_2', '2000');
      add_option('news_ticker_benaceur_speed_scrollntb_', '10');
      add_option('news_ticker_benaceur_pause_scrollntb', 'checked');
      add_option('news_ticker_benaceur_expt_title_scrollntb', '28');
      add_option('news_ticker_benaceur_all_scrollntb', 'checked');
      add_option('news_ticker_benaceur_dis_fin_img_scrollntb', '48');
      add_option('news_ticker_benaceur_dis_fin_no_img_scrollntb', '10');
      add_option('news_ticker_benaceur_disa_img_n_scrollup', 'enable_img_n_scrollup');
      add_option('news_ticker_benaceur_disa_img_n_fadein', 'enable_img_n_fadein');
      add_option('news_ticker_benaceur_timeout_slide_up_down', '4000');
      add_option('news_ticker_benaceur_speed_slide_up_down', '450');
      add_option('news_ticker_benaceur_updown_slide_up_down', 'up_slide_u_d');
      add_option('news_ticker_benaceur_timeout_fadein', '4000');
      add_option('news_ticker_benaceur_width_anms__two', '5');
      add_option('news_ticker_benaceur_width_typing__2', '5');
      add_option('news_ticker_benaceur_timeout_no_scr_typ', '3000');
      add_option('news_ticker_benaceur_speed_no_scr_typ', '10');
      add_option('news_ticker_benaceur_margin_top_no_scr_typ', '12');
      add_option('news_ticker_benaceur_margin_left_ltr_no_scr_typ', '-12');
      add_option('news_ticker_benaceur_margin_right_ltr_no_scr_typ', '-12');
      add_option('news_ticker_benaceur_cursor_no_scr_typ', '15');
      add_option('news_ticker_benaceur_cursor_top_no_scr_typ_', '10');
      add_option('news_ticker_benaceur_cursor_margin_left_right_no_scr_typ', '8');
      add_option('news_ticker_benaceur_NP_img_no_scr_typ', 'enable');
      add_option('news_ticker_benaceur_ENABLE_curs_no_scr_typ', 'enable');
      add_option('news_ticker_benaceur_NP_img_anms_two', 'enable');
      add_option('news_ticker_benaceur_NP_img_typing_2', 'enable');
      add_option('news_ticker_benaceur_pause_anms_two', 'checked');
      add_option('news_ticker_benaceur_pause_typing_2', 'checked');
      add_option('news_ticker_benaceur_pause_slide_up_down', 'checked');
      add_option('news_ticker_benaceur_pause_fadein', 'checked');
      add_option('news_ticker_benaceur_pause_typing', 'checked');
      add_option('news_ticker_benaceur_dist_from_left_right_fadein', '5');
      add_option('news_ticker_benaceur_dist_from_left_right_scrollup', '5');
      add_option('news_ticker_benaceur_dist_from_left_right_scrollntb', '5');
      add_option('news_ticker_benaceur_dist_between_scrollntb', '2');
      add_option('news_ticker_benaceur_w_img_scrollntb', '20');
      add_option('news_ticker_benaceur_h_img_scrollntb', '17');
      add_option('news_ticker_benaceur_ri_le_img_scrollntb', '5');
      add_option('news_ticker_benaceur_le_ri_img_scrollntb', '22');
	 }
	 
     function group_sty_options_default() {
      add_option('news_ticker_benaceur_color_back_', '#FFFFFF');
      add_option('news_ticker_benaceur_color_back_title', '#CE0000');
      add_option('news_ticker_benaceur_color_text_back', '#000000');
      add_option('news_ticker_benaceur_color_text_title', '#FFFFFF');
      add_option('news_ticker_benaceur_color_border', '#CE1031');
      add_option('news_ticker_benaceur_border_top', '0');
      add_option('news_ticker_benaceur_border_bottom', '2');
      add_option('news_ticker_benaceur_border_right', '0');
      add_option('news_ticker_benaceur_border_left', '0');
      add_option('news_ticker_benaceur_border_radius', '1');
      add_option('news_ticker_benaceur_opacity', '1');
      add_option('news_ticker_benaceur_font_family', 'DroidKufi_Ben, Tahoma, Arial');
      add_option('news_ticker_benaceur_font_size', '14');
      add_option('news_ticker_benaceur_font_size_title', '14');
      add_option('news_ticker_benaceur_width', '100%');
      add_option('news_ticker_benaceur_padding_top', '0');
      add_option('news_ticker_benaceur_padding_bottom', '0');
      add_option('news_ticker_benaceur_margin_top', '0');
      add_option('news_ticker_benaceur_margin_bottom', '25');
      add_option('news_ticker_benaceur_font_weight', 'normal');
      add_option('news_ticker_benaceur_text_shadow', 'no');
      add_option('news_ticker_benaceur_text_shadow_color', '#000000');
      add_option('news_ticker_benaceur_box_shadow', 'no');
      add_option('news_ticker_benaceur_box_shadow_color', '#B5B5B5');
      add_option('news_ticker_benaceur_box_shadow_v', '1');
      add_option('news_ticker_benaceur_PrevNext_color', '#8F8F8F');
      add_option('news_ticker_benaceur_PrevNext_font_size', '26');
      add_option('news_ticker_benaceur_PrevNext_weight', 'normal');
      add_option('news_ticker_benaceur_PrevNext_top', '0');
      add_option('news_ticker_benaceur_title_font_family', 'DroidKufi_Ben, Tahoma, Arial');
      add_option('news_ticker_benaceur_enable_style_mobile', 'checked');
      add_option('news_ticker_benaceur_screen_max_width', '782');
      add_option('news_ticker_benaceur_screen_min_width', '783');
      add_option('news_ticker_benaceur_height_mobile', '65');
      add_option('news_ticker_benaceur_padding_top_mobile', '10');
      add_option('news_ticker_benaceur_padding_right_left_mobile', '10');
      add_option('news_ticker_benaceur_min_height_mobile', '56');
      add_option('news_ticker_benaceur_line_height_mobile', '24');
      add_option('news_ticker_benaceur_v_screen_max_width', '782');
      add_option('news_ticker_benaceur_height', '42');
      add_option('news_ticker_benaceur_a_hover', '#847c7c');
      add_option('news_ticker_benaceur_width_title_background', '90');
      add_option('news_ticker_benaceur_color_border_title', '#FFFFFF');
      add_option('news_ticker_benaceur_border_title', '0');
      add_option('news_ticker_benaceur_line_height_title', '42');
      add_option('news_ticker_benaceur_time_export_sett_gmt', '1');
	 }
	 
     function group_op_options_default() {
      add_option('news_ticker_benaceur_delete_all_options', 'no_delete_opt');
      add_option('news_ticker_benaceur_ntb_st_code', 'not_remove');
	 }
	 
     function options_default_new() {
	 add_option('news_ticker_benaceur_for_cat_tax', 'category');
	 add_option('news_ticker_benaceur_expt_title_scrollntb', '28');
     add_option('news_ticker_benaceur_all_scrollntb', 'checked');
     add_option('news_ticker_benaceur_dis_fin_img_scrollntb', '48');
     add_option('news_ticker_benaceur_dis_fin_no_img_scrollntb', '10');
     add_option('news_ticker_benaceur_width_anms__two', '5');
	 add_option('news_ticker_benaceur_width_typing__2', '5');
     add_option('news_ticker_benaceur_dist_between_scrollntb', '2');
     add_option('news_ticker_benaceur_w_img_scrollntb', '20');
     add_option('news_ticker_benaceur_h_img_scrollntb', '17');
     add_option('news_ticker_benaceur_ri_le_img_scrollntb', '5');
     add_option('news_ticker_benaceur_le_ri_img_scrollntb', '22');
     add_option('news_ticker_benaceur_speed_scrollntb_', '10');
     add_option('news_ticker_benaceur_post_type', 'post');
     add_option('news_ticker_benaceur_post_status', 'publish');
     add_option('news_ticker_benaceur_comment_status', 'approve');
	 }
	 
    function options_default_up() {
	$ver = get_option('news_ticker_benaceur_version');	

    if ( $ver === false ) { 
	add_option( 'news_ticker_benaceur_version', NTB_VERSION_BEN);
	
    $this->group_options_default();
	$this->group_anim_options_default();
	$this->group_sty_options_default();
	$this->group_op_options_default();
    } else if ( $ver != NTB_VERSION_BEN ) { 
	$this->options_default_new();
	
	update_option( 'news_ticker_benaceur_version', NTB_VERSION_BEN);
    }
	
	}
	// add_option
	
     function up_options(){
     if ( version_compare( get_bloginfo('version'), '3.0', '<') )  { 
        deactivate_plugins( basename( __FILE__ ) ); 
			die(__('<strong>Core Control:</strong> Sorry, This plugin requires WordPress 3.0+', 'core-control'));
	 } else {
	    add_option('ntb_do_activation_redi', true);	
	 }
	 }

     function activ_redir() {
     if (get_option('ntb_do_activation_redi', false)) {
        delete_option('ntb_do_activation_redi');
		if(!isset($_GET['activate-multi']) && $GLOBALS['pagenow'] != 'plugin-editor.php') {
        wp_redirect( admin_url( 'options-general.php?page='.NS_TR_BEN.'' ) ) ;
		}
     }
     }
	 
    function js_page_panel(){
	wp_enqueue_script ('js-page-panel', plugins_url('admin/js.js',__FILE__), array(), '1.0.1', true);
	wp_enqueue_style( 'style-NTB', plugin_dir_url( __FILE__ ) . 'admin/style.css', '', '1.0.1' );
    }

    function wp_news_ticker_benaceur___() { 
		$this->ntb_hide();
    }
	
	function enable_plug(){
	if (get_option( 'news_ticker_benaceur_enable_plug' ))
	return true;
	return false;
	}
	
	function shortcode_ntb_func($atts){
		if ($this->enable_plug() === false) return;
		ob_start();
		$this->wp_news_ticker_benaceur___();
		$content = ob_get_contents();
		ob_end_clean();

	    return $content;
    }
	
    //if ($this->enable_plug()) {

	function pagePHP() {
	if ($this->enable_plug() === false) return;	
    return require_once('news-ticker-benaceur-page.php');
    }
   
	function expt_title_text($text, $length = 0) {
		if (defined('MB_OVERLOAD_STRING')) {
		  $text = @html_entity_decode($text, ENT_QUOTES, get_option('blog_charset'));
		 	if (mb_strlen($text) > $length) {
				return htmlentities(mb_substr($text,0,$length), ENT_COMPAT, get_option('blog_charset')).'...';
		 	} else {
				return htmlentities($text, ENT_COMPAT, get_option('blog_charset'));
		 	}
		} else {
			$text = @html_entity_decode($text, ENT_QUOTES, get_option('blog_charset'));
		 	if (strlen($text) > $length) {
				return htmlentities(substr($text,0,$length), ENT_COMPAT, get_option('blog_charset')).'...';
		 	} else {
				return htmlentities($text, ENT_COMPAT, get_option('blog_charset'));
		 	}
		}
	}

  function ntb_hide() {
  list($go_ea,$ntb_in_home,$ntb_in_single,$ntb_in_author,$ntb_in_page,$ntb_in_category,$ntb_in_search,$ntb_in_page_id,$ntb_in_single_id) = $this->v1();	
  
  if ($this->enable_plug() === false) return;	
  $admin_ntb = current_user_can( 'administrator' ); 
  $ntb_in_page_id_arr = explode(',', $ntb_in_page_id); 
  $ntb_in_single_id_arr = explode(',', $ntb_in_single_id);  

	if ( ( $this->role_cap_ntb() && $this->all_users_ntb() && $this->id_user_ntb() && is_user_logged_in() )  || ( $this->visitors_ntb() && !is_user_logged_in() ) || $go_ea )
    {
    if (!$go_ea || $admin_ntb) {
    if (!$ntb_in_home && is_home() || !$ntb_in_home && is_front_page()) {
		$this->pagePHP();
    } elseif (!$ntb_in_category && is_category()) {
		$this->pagePHP();
    } elseif (!$ntb_in_author && is_author()) {
		$this->pagePHP();
    } elseif (!$ntb_in_search && is_search()) {
		$this->pagePHP();
    } elseif (!$ntb_in_single && is_single($ntb_in_single_id_arr)) {
		$this->pagePHP();
    } elseif (!$ntb_in_single && is_single()) {
		$this->pagePHP();
    } elseif (!$ntb_in_page && is_page($ntb_in_page_id_arr)) {
		$this->pagePHP();
    } elseif (!$ntb_in_page && is_page()) {
		$this->pagePHP();
    } elseif ($ntb_in_home && is_home() || $ntb_in_home && is_front_page() ||
          $ntb_in_category && is_category() || $ntb_in_author && is_author() || $ntb_in_search && is_search() ||
		  $ntb_in_page && is_page() && empty($ntb_in_page_id) ||
		  $ntb_in_single && is_single() && empty($ntb_in_single_id)) {
	    return NULL;
    } elseif ($ntb_in_single && is_single($ntb_in_single_id_arr)) {
	    return NULL;
    } elseif ($ntb_in_page && is_page($ntb_in_page_id_arr)) {
	    return NULL;
    } else {
		$this->pagePHP();
    }
    }		
    }
	
    }

    function scripts_() {
	list($dir,$ntb_st,$ntb_pause_scrollntb,$ntb_speed_scrollntb,$array_anim_two,$ntb_ena_js_scrollntb) = $this->v2();	
	
	if ($this->enable_plug() === false) return;	
	if ( !is_admin() && $ntb_st == 'ScrollNTB' ) {
			wp_register_script('jquery-scrollntb', false);
			wp_enqueue_script( 'jquery-scrollntb' );
	$ntb_js_scr_params = array(
	        'mouse'     => $ntb_pause_scrollntb ? true : false,
			'ori_scr'     => ($dir == 'auto' && !is_rtl() || $dir == 'ltr') ? "right" : "left",
	        'speed_scr'     => $ntb_speed_scrollntb 
		);
		wp_localize_script( 'jquery-scrollntb', 'ntb_scr_js', $ntb_js_scr_params );
	} if ( !is_admin() && !in_array($ntb_st, $array_anim_two) ) {
	if ($ntb_ena_js_scrollntb) {	
	wp_register_script ('ntb_js-anim-two', plugins_url('js/cy_min.js',__FILE__), array('jquery'), '1.0.0');
	} else {	
	wp_register_script ('ntb_js-anim-two', false, array('jquery'), false);
	}
	wp_enqueue_script( 'ntb_js-anim-two' );
	$rtl = (is_rtl() && $dir != 'ltr' || !is_rtl() && $dir == 'rtl') ? true : false ;
	$ntb_js_two_params = array(
	        'rtl'     => $rtl ? 'right' : 'left',
	        'ocb'     => $rtl ? 'opts.cssBefore.right' : 'opts.cssBefore.left'
		);
		wp_localize_script( 'ntb_js-anim-two', 'ntb_two', $ntb_js_two_params );
	}
    }
	

    //} // enable_plug	

	function get_settings() {

		$settings = array( 
			'rolexcap_ntb' => (array) get_option( 'news_ticker_benaceur_for_role_x', array() )
		);

		$settings[ 'rolexcap_ntb' ] = array_map( 'trim', array_unique( array_filter( $settings[ 'rolexcap_ntb' ] ) ) );
		
		return $settings;
		
	}

    function id_user_ntb() {

	$current_user = wp_get_current_user();
	$user_id = get_current_user_id();
	
	$iduser_ntb = explode(',', get_option('news_ticker_benaceur_for_user_id'));
	
	if(is_array($iduser_ntb)) {
		
		foreach($iduser_ntb as $user_id) {
			
			if( $current_user->ID == $user_id ) {
				
			return false;
			}
		}
	}
	
			return true;
    }

    function role_cap_ntb() {

        $settings = $this->get_settings();	
		$rolexcap_ntb = $settings[ 'rolexcap_ntb' ];
		
		if ( !empty( $rolexcap_ntb ) ) {
			if ( !is_array( $rolexcap_ntb ) )
				$rolexcap_ntb = array( $rolexcap_ntb );

			foreach ( $rolexcap_ntb as $role ) {
			
			if ( current_user_can( $role ) ) {
				
	return false;
			}
		}
	}
	
	return true;
    }

    function all_users_ntb() {
	
	if(get_option('news_ticker_benaceur_for_users')) {
		
		if(is_user_logged_in()) {
			
			return false;
		}
	}
	
	return true;
    }

    function visitors_ntb() {
		
	if(get_option('news_ticker_benaceur_for_visitors'))
	return false;
	return true;
    }

    function links_on_admin_bar($wp_admin_bar) {
	list($ntb_links_admin_bar_front,$ntb_links_admin_bar_menu,$ntb_links_admin_bar_admin) = $this->v3();	

    if (current_user_can( 'manage_options' ) && $ntb_links_admin_bar_front && !is_admin() && $this->enable_plug()) {
    if ($ntb_links_admin_bar_menu == 'menu') {
    $wp_admin_bar->add_menu( array( 'id' => 'PLB_ntb5', 'title' => __('News Ticker Benaceur'), 'href' => admin_url('/'.NTB_BEN_O_G.'?page=news_ticker_benaceur' ) ) );
    } elseif ($ntb_links_admin_bar_menu == 'submenu' ) { 
    $wp_admin_bar->add_menu( array( 'parent' => 'appearance', 'id' => 'PLB_ntb6', 'title' => __('News Ticker Benaceur'), 'href' => admin_url('/'.NTB_BEN_O_G.'?page=news_ticker_benaceur' ) ) );
    }
	} elseif (current_user_can( 'manage_options' ) && $ntb_links_admin_bar_admin && is_admin() && $this->enable_plug())  {
    if ($ntb_links_admin_bar_menu == 'menu') {
    $wp_admin_bar->add_menu( array( 'id' => 'PLB_ntb7', 'title' => __('News Ticker Benaceur'), 'href' => admin_url('/'.NTB_BEN_O_G.'?page=news_ticker_benaceur' ) ) );
    } elseif ($ntb_links_admin_bar_menu == 'submenu') { 
    $wp_admin_bar->add_menu( array( 'parent' => 'site-name', 'id' => 'PLB_ntb8', 'title' => __('News Ticker Benaceur'), 'href' => admin_url('/'.NTB_BEN_O_G.'?page=news_ticker_benaceur' ) ) );
    }
		}	
    }

    function admin_notices() {
    $ntb_notice_admin = false;
    if ( $ntb_notice_admin && $GLOBALS['pagenow'] == NTB_BEN_O_G && isset($_GET['page']) && $_GET['page'] == NS_TR_BEN ) {
    require_once ('includes/notices-ntb.php');
    }
	}

    function page_options() {
    return require_once ('opts-page.php');
	}

    function plugin_deactivation() {
    global $wpdb;
	$NTB_sht_code = "[wp_news_ticker_benaceur_short_code]";
	$ntb_delete_all_options = get_option( 'news_ticker_benaceur_delete_all_options' );
    $NTB_st_code = get_option( 'news_ticker_benaceur_ntb_st_code' );


    if ( $ntb_delete_all_options == 'delete_opt') {
    foreach($this->AllOptionsNTB() as $optionN_NTB) {
     delete_option($optionN_NTB);
    }

    foreach($this->AllOptionssNTB() as $optionS_NTB ) {
     delete_option($optionS_NTB);
    }

    foreach($this->AllOptions_anim_NTB() as $optionN_anim_NTB ) {
     delete_option($optionN_anim_NTB);
    }
     delete_option('news_ticker_benaceur_delete_all_options');
     delete_option('ntb_all_reset');
	 delete_option( 'news_ticker_benaceur_version');
	 delete_option('news_ticker_benaceur_ntb_st_code');
    }
  
    if ( $NTB_st_code == 'remove') {
    $wpdb->get_results( "UPDATE $wpdb->posts SET post_content = replace(post_content, '$NTB_sht_code', '') " );
    delete_option('news_ticker_benaceur_ntb_st_code');
    }
  
    }
  
  function reset_options() {
  
// reset group
   if (get_option('ntb_group_reset')) {
   delete_option('ntb_group_reset');
   $this->group_options_default_up();
   }
// reset group

// reset group anim
  if (get_option('ntb_group_anim_reset')) {
  delete_option('ntb_group_anim_reset');
  $this->group_anim_options_default_up();
  }
// reset group anim

// reset group sty
  if (get_option('ntb_group_sty_reset')) {
  delete_option('ntb_group_sty_reset');
  $this->group_sty_options_default_up();
  }  
// reset group sty

// reset all
  if (get_option('ntb_all_reset')) {
     delete_option('news_ticker_benaceur_delete_all_options');
     delete_option('ntb_all_reset');
      $this->group_options_default_up();
      $this->group_anim_options_default_up();
      $this->group_sty_options_default_up();
	  $this->group_op_options_default_up();
	  update_option( 'news_ticker_benaceur_version', NTB_VERSION_BEN);
  }  
// reset all

  }

    function msg_update_func() {
        do_action('wp_ntb_msg_update');
    }

    function verPlug(){
    $ntb_plugin = "".NTB_BEN_NAME."/".NTB_BEN_NAME.".php";

    // $update_plugins = get_site_transient('update_plugins');
    // if ( isset( $update_plugins->response[ $ntb_plugin ] ) ) { 
			
                $update_file = $ntb_plugin;
                $url = wp_nonce_url(self_admin_url('update.php?action=upgrade-plugin&plugin=' . $update_file), 'upgrade-plugin_' . $update_file);
    if ($this->ntb_version() < $this->latest_version("news-ticker-benaceur")) {
    echo "<div class='ntb-mm411112'><div id='ntb-mm411112-divtoBlink'>". __("You are using Version",'news-ticker-benaceur').' '.$this->ntb_version().", ". __("There is a newer version, it's recommended to",'news-ticker-benaceur')." <a href=".$url.">". __("update now",'news-ticker-benaceur')."</a>.</div></div>";
    echo "
    <script>
    (function($) {
    $('.ntb-mm4111172p').delay(400).slideToggle('slow');
    })(jQuery); 
    </script>";
    }
    // } 
    }

    function process_settings_export_import() {
    require_once ('includes/ie-setts.php');
	}

}

    // var
	require_once ('includes/news-ticker-benaceur-var.php'); // class two
    // var
    require_once ('includes/reset.php'); // class three
	
	new class______NTB_UP_options_default;

